> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Add grants to a connection

POST https://api.sigmacomputing.com/v2/connections/{connectionId}/grants
Content-Type: application/json

Add grants to grant permissions on a connection to specific users or teams.

  ### Usage notes
  - See [Data permissions overview](https://help.sigmacomputing.com/docs/data-permissions-overview) for details about permissions that can be granted on a connection.
  - Retrieve the **connectionId** by calling the [/v2/connections](https://help.sigmacomputing.com/reference/list-connections) endpoint.
  - Specify the team or user IDs to grant permissions:

    - Retrieve the **memberId** by calling the [/v2/members](https://help.sigmacomputing.com/reference/list-members) endpoint.
    - Retrieve the **teamId** by calling the [/v2/teams](https://help.sigmacomputing.com/reference/list-teams) endpoint.

  ### Usage scenarios
  - Grant a specific team `Can use` access to a connection. 

Reference: https://help.sigmacomputing.com/reference/create-connection-grant

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/connections/{connectionId}/grants:
    post:
      operationId: createConnectionGrant
      summary: Add grants to a connection
      description: >-
        Add grants to grant permissions on a connection to specific users or
        teams.

          ### Usage notes
          - See [Data permissions overview](https://help.sigmacomputing.com/docs/data-permissions-overview) for details about permissions that can be granted on a connection.
          - Retrieve the **connectionId** by calling the [/v2/connections](https://help.sigmacomputing.com/reference/list-connections) endpoint.
          - Specify the team or user IDs to grant permissions:

            - Retrieve the **memberId** by calling the [/v2/members](https://help.sigmacomputing.com/reference/list-members) endpoint.
            - Retrieve the **teamId** by calling the [/v2/teams](https://help.sigmacomputing.com/reference/list-teams) endpoint.

          ### Usage scenarios
          - Grant a specific team `Can use` access to a connection. 
      tags:
        - Connections
      parameters:
        - name: connectionId
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/connections_createConnectionGrant_Response_200
      requestBody:
        description: The request body.
        content:
          application/json:
            schema:
              type: object
              properties:
                grants:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/V2ConnectionsConnectionIdGrantsPostRequestBodyContentApplicationJsonSchemaGrantsItems
              required:
                - grants
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2ConnectionsConnectionIdGrantsPostRequestBodyContentApplicationJsonSchemaGrantsItemsGrantee0:
      type: object
      properties:
        memberId:
          type: string
      required:
        - memberId
      description: The UUID of the member receiving the grant
      title: >-
        V2ConnectionsConnectionIdGrantsPostRequestBodyContentApplicationJsonSchemaGrantsItemsGrantee0
    V2ConnectionsConnectionIdGrantsPostRequestBodyContentApplicationJsonSchemaGrantsItemsGrantee1:
      type: object
      properties:
        teamId:
          type: string
      required:
        - teamId
      description: The UUID of the team receiving the grant
      title: >-
        V2ConnectionsConnectionIdGrantsPostRequestBodyContentApplicationJsonSchemaGrantsItemsGrantee1
    V2ConnectionsConnectionIdGrantsPostRequestBodyContentApplicationJsonSchemaGrantsItemsGrantee:
      oneOf:
        - $ref: >-
            #/components/schemas/V2ConnectionsConnectionIdGrantsPostRequestBodyContentApplicationJsonSchemaGrantsItemsGrantee0
        - $ref: >-
            #/components/schemas/V2ConnectionsConnectionIdGrantsPostRequestBodyContentApplicationJsonSchemaGrantsItemsGrantee1
      title: >-
        V2ConnectionsConnectionIdGrantsPostRequestBodyContentApplicationJsonSchemaGrantsItemsGrantee
    V2ConnectionsConnectionIdGrantsPostRequestBodyContentApplicationJsonSchemaGrantsItemsPermission:
      type: string
      enum:
        - annotate
        - usage
      description: Connection permissions of Can Use & Annotate and Can Use.
      title: >-
        V2ConnectionsConnectionIdGrantsPostRequestBodyContentApplicationJsonSchemaGrantsItemsPermission
    V2ConnectionsConnectionIdGrantsPostRequestBodyContentApplicationJsonSchemaGrantsItems:
      type: object
      properties:
        grantee:
          $ref: >-
            #/components/schemas/V2ConnectionsConnectionIdGrantsPostRequestBodyContentApplicationJsonSchemaGrantsItemsGrantee
        permission:
          $ref: >-
            #/components/schemas/V2ConnectionsConnectionIdGrantsPostRequestBodyContentApplicationJsonSchemaGrantsItemsPermission
          description: Connection permissions of Can Use & Annotate and Can Use.
      required:
        - grantee
        - permission
      title: >-
        V2ConnectionsConnectionIdGrantsPostRequestBodyContentApplicationJsonSchemaGrantsItems
    connections_createConnectionGrant_Response_200:
      type: object
      properties: {}
      title: connections_createConnectionGrant_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Request**

```json
{
  "grants": [
    {
      "grantee": {
        "memberId": "a3f1c9e2-7b4d-4f8a-9d3e-2b5f6c7d8e9f"
      },
      "permission": "annotate"
    }
  ]
}
```

**Response**

```json
{}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/connections/connectionId/grants"

payload = { "grants": [
        {
            "grantee": { "memberId": "a3f1c9e2-7b4d-4f8a-9d3e-2b5f6c7d8e9f" },
            "permission": "annotate"
        }
    ] }
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/connections/connectionId/grants';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{"grants":[{"grantee":{"memberId":"a3f1c9e2-7b4d-4f8a-9d3e-2b5f6c7d8e9f"},"permission":"annotate"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/connections/connectionId/grants"

	payload := strings.NewReader("{\n  \"grants\": [\n    {\n      \"grantee\": {\n        \"memberId\": \"a3f1c9e2-7b4d-4f8a-9d3e-2b5f6c7d8e9f\"\n      },\n      \"permission\": \"annotate\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/connections/connectionId/grants")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"grants\": [\n    {\n      \"grantee\": {\n        \"memberId\": \"a3f1c9e2-7b4d-4f8a-9d3e-2b5f6c7d8e9f\"\n      },\n      \"permission\": \"annotate\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/connections/connectionId/grants")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{\n  \"grants\": [\n    {\n      \"grantee\": {\n        \"memberId\": \"a3f1c9e2-7b4d-4f8a-9d3e-2b5f6c7d8e9f\"\n      },\n      \"permission\": \"annotate\"\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/connections/connectionId/grants', [
  'body' => '{
  "grants": [
    {
      "grantee": {
        "memberId": "a3f1c9e2-7b4d-4f8a-9d3e-2b5f6c7d8e9f"
      },
      "permission": "annotate"
    }
  ]
}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/connections/connectionId/grants");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"grants\": [\n    {\n      \"grantee\": {\n        \"memberId\": \"a3f1c9e2-7b4d-4f8a-9d3e-2b5f6c7d8e9f\"\n      },\n      \"permission\": \"annotate\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = ["grants": [
    [
      "grantee": ["memberId": "a3f1c9e2-7b4d-4f8a-9d3e-2b5f6c7d8e9f"],
      "permission": "annotate"
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/connections/connectionId/grants")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```